unit Fmattr;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons;

type
  TFmSetAttr = class(TForm)
    CheckBox1: TCheckBox;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    CBArchive: TCheckBox;
    CBReadOnly: TCheckBox;
    CBSysFile: TCheckBox;
    CBHidden: TCheckBox;
    DateEdit: TEdit;
    TimeEdit: TEdit;
    CheckBox6: TCheckBox;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Label1: TLabel;
    BitBtn1: TBitBtn;
    Label2: TLabel;
    Label3: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    AttrSet,
    AttrClear: word;
    FileDate: longint;
  public
    { Public declarations }
  end;

var
  FmSetAttr: TFmSetAttr;

implementation

{$R *.DFM}

procedure TFmSetAttr.FormCreate(Sender: TObject);
begin
 Left:=(Owner as TForm).Left+((Owner as TForm).Width-Width) div 2;
 Top:=(Owner as TForm).Top+((Owner as TForm).Height-Height) div 2;
end;

procedure TFmSetAttr.BitBtn1Click(Sender: TObject);
begin
 DateEdit.Text:=DateToStr(Now);
 TimeEdit.Text:=TimeToStr(Now);
end;

procedure TFmSetAttr.FormShow(Sender: TObject);
begin
 FileDate:=0;
end;

procedure TFmSetAttr.FormClose(Sender: TObject; var Action: TCloseAction);
var DT: TDateTime;
begin
 if CheckBox6.Checked then
  begin
   try
    DT:=StrToTime(TimeEdit.Text)+StrToDate(DateEdit.Text);
    FileDate:=DateTimeToFileDate(DT);
   except
    Application.MessageBox('Invalid time or date.','Atari Portfolio Manager',
                           mb_ok+mb_iconstop);
    Action:=caNone;
   end;
  end;
end;

end.
