{last modified 12.5.2014}

{buglist
 PANEL
 -improve functionality PanelRefresh
  -detect non existing directory
  -add ability to change disk when device is not responding
 -change directory when move across them?
 -refresh panel when application get focus
 -make procedure SetPanelStyle solving behaviour THeader
  in full/brief style
 -in brief style works inedit only in first column
 -when change disk same as another panel set this path

 SHELLEXEC
 -new ShellExec is under construction
 -make function PfFindExecutable

 BATCH PROCESSING
 -in move repair numbering of files
 -when error delete part of copied file
 -ask before deleting non empty directory
 -don't show message 'access denied' during RemoveDir when skip
  file in DeleteFile

 PF
 -revert strobe

 OTHER
 -tool box is under construction
 -128kB Ram card sends bad free space
 -after inplace rename set right focus
 -repair Cancel in SetAttr
}
{todo
-user command
-when press space on dir count size like TotalCommander

-edit/view
 -hook function
-port on 32bit platform
}

unit Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Buttons, Menus, IniFiles, ShellApi,
  FObj,FmNewDir,Fmnewlab,FmSysDt,FmMask, PFDrives, Pf, NetDlgs, inedit,
  FmBatch, FmAssoc, Fmattr, Fmoption, FmAbout;

const WM_PANELREFRESH=WM_USER+1;

type
  TPanelType = (ptLeftPanel,ptRightPanel);
  TPanelStyle = (psFull,psBrief);
  TSelAction = (saSelect,saUnselect,saInvert);
  TPanelInfo = record
    Drive: string[1];
    Path: string;
    Mask: string;
    Sort: TSortType;
    Style: TPanelStyle;
    Active: boolean;
    KbAll: longint;
    KbSel:longint;
    NumFiles:integer;
    NumSelFiles:integer;
    NumDirs:integer;
    NumSelDirs:integer;
    LastItemIndex:integer;
    DriveComboBox: TComboBox;
    RootButton: TSpeedButton;
    UpDirButton: TSpeedButton;
    TopLabel: TLabel;
    BottomLabel: TLabel;
    SizeLabel: TLabel;
    Header: THeader;
    ListBox: TListBox;
    Panel: TPanel;
   end;
  TPanelArray=array[ptLeftPanel..ptRightPanel] of TPanelInfo;

  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Panel1: TPanel;
    BottomPanel: TPanel;
    LeftPanel: TPanel;
    Panel4: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    ListBox1: TListBox;
    Label2: TLabel;
    Header1: THeader;
    Label3: TLabel;
    sb2: TSpeedButton;
    sb4: TSpeedButton;
    sb5: TSpeedButton;
    Label4: TLabel;
    CommandComboBox: TComboBox;
    Label5: TLabel;
    ListBox2: TListBox;
    Header2: THeader;
    Label6: TLabel;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    ComboBox3: TComboBox;
    ComboBox1: TComboBox;
    sb3: TSpeedButton;
    sb1: TSpeedButton;
    Show1: TMenuItem;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Image5: TImage;
    Label1: TLabel;
    Label7: TLabel;
    Mark1: TMenuItem;
    Configuration1: TMenuItem;
    Changeatributes1: TMenuItem;
    N1: TMenuItem;
    Volumelabel1: TMenuItem;
    N2: TMenuItem;
    RunDOS1: TMenuItem;
    N3: TMenuItem;
    Newfolder1: TMenuItem;
    Copyfiles1: TMenuItem;
    MoveRename1: TMenuItem;
    Delete1: TMenuItem;
    Selectgroup1: TMenuItem;
    Unselectgroup1: TMenuItem;
    Selectall1: TMenuItem;
    Unselect1: TMenuItem;
    Brief1: TMenuItem;
    Full1: TMenuItem;
    N4: TMenuItem;
    VertItem: TMenuItem;
    AllFilesItem: TMenuItem;
    MaskItem: TMenuItem;
    Custom1: TMenuItem;
    N5: TMenuItem;
    Name1: TMenuItem;
    Extension1: TMenuItem;
    Time1: TMenuItem;
    Size1: TMenuItem;
    Opto1: TMenuItem;
    Usercommands1: TMenuItem;
    Portfolioasociations1: TMenuItem;
    N6: TMenuItem;
    Synchronizesystemdatetime1: TMenuItem;
    Invertselection1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    Image6: TImage;
    ProgramsItem: TMenuItem;
    Onlyselectedfiles1: TMenuItem;
    Net1: TMenuItem;
    Networkconnections1: TMenuItem;
    DisconnectNetworkDrives1: TMenuItem;
    ShareCurrentDirectory1: TMenuItem;
    UnshareDirectory1: TMenuItem;
    NetConnectDialog1: TNetConnectDialog;
    NetDisconnectDialog1: TNetDisconnectDialog;
    NetShareAsDialog1: TNetShareAsDialog;
    NetStopShareDialog1: TNetStopShareDialog;
    InPlaceEdit: TInEdit;
    Timer1: TTimer;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure Header1Sized(Sender: TObject; ASection, AWidth: Integer);
    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure ComboBox1DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure Exit1Click(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure ListBox1KeyPress(Sender: TObject; var Key: Char);
    procedure ListBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ComboBox1Exit(Sender: TObject);
    procedure CommandComboBoxExit(Sender: TObject);
    procedure Newfolder1Click(Sender: TObject);
    procedure VertItemClick(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Volumelabel1Click(Sender: TObject);
    procedure Synchronizesystemdatetime1Click(Sender: TObject);
    procedure Name1Click(Sender: TObject);
    procedure Extension1Click(Sender: TObject);
    procedure Time1Click(Sender: TObject);
    procedure Size1Click(Sender: TObject);
    procedure NotImplemented(Sender: TObject);
    procedure Selectall1Click(Sender: TObject);
    procedure Unselect1Click(Sender: TObject);
    procedure Invertselection1Click(Sender: TObject);
    procedure ListBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Selectgroup1Click(Sender: TObject);
    procedure Unselectgroup1Click(Sender: TObject);
    procedure Custom1Click(Sender: TObject);
    procedure RunDOS1Click(Sender: TObject);
    procedure CommandComboBoxKeyPress(Sender: TObject; var Key: Char);
    procedure CommandComboBoxDblClick(Sender: TObject);
    procedure AllFilesItemClick(Sender: TObject);
    procedure MaskItemClick(Sender: TObject);
    procedure Networkconnections1Click(Sender: TObject);
    procedure DisconnectNetworkDrives1Click(Sender: TObject);
    procedure ShareCurrentDirectory1Click(Sender: TObject);
    procedure UnshareDirectory1Click(Sender: TObject);
    procedure InPlaceEditGoingOff(Sender: TObject; Reason: TGoingOffReason;
      Value: String; var AllowExit: Boolean);
    procedure Copyfiles1Click(Sender: TObject);
    procedure MoveRename1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure Changeatributes1Click(Sender: TObject);
    procedure ListBox1Enter(Sender: TObject);
    procedure ListBox1Exit(Sender: TObject);
    procedure Label2Click(Sender: TObject);
    procedure Label6Click(Sender: TObject);
    procedure ComboBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ComboBox3KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ComboBox3Change(Sender: TObject);
    procedure ComboBox3Exit(Sender: TObject);
    procedure ComboBox1Enter(Sender: TObject);
    procedure ComboBox3Enter(Sender: TObject);
    procedure ListBox2Enter(Sender: TObject);
    procedure ListBox2Exit(Sender: TObject);
    procedure ProgramsItemClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure AppMessage(var Msg: TMsg; var Handled: Boolean);
    procedure Brief1Click(Sender: TObject);
    procedure Full1Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure Portfolioasociations1Click(Sender: TObject);
    procedure Opto1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
  private
    { Private declarations }
    FTIniFile: TIniFile;
    ActivePanel: TPanelType;
    Panel: TPanelArray;
    Vert:boolean;
    CB1OldValue:Integer;
    CB2OldValue:Integer;
    LastClicked: integer;
    LastSelection:string;
  public
    { Public declarations }
    procedure Msg(Mess:string);
    procedure GoUpdir;
    procedure BuildDriveList;
    procedure ShellExec;
    procedure SelectAction(Action: TSelAction);
    procedure SelectGroup(Select: boolean);
    procedure UpdateMaskMenu(Mask: string; AllFiles: boolean);
    function  GetVolumeStr(aDrive:string):string;
    procedure SetComboBoxVolume(Index: integer);
    procedure PanelResize(PanelIndex: TPanelType);
    procedure PanelReadFromIni(PanelIndex: TPanelType);
    procedure PanelSaveToIni(PanelIndex: TPanelType);
    procedure PanelRefresh(PanelIndex: TPanelType);
    procedure PanelActivate(PanelIndex: TPanelType; Act:boolean);
    procedure PanelUpdateBL(PanelIndex:TPanelType);
    procedure PanelUpdateSL(PanelIndex:TPanelType);
    function  DoAction(SourcePath,DestPath: string; FileRec: TFileRec;
                       AttrSet, AttrClear: word; lTime: longint):integer;
    procedure DoBatchAction(Act: byte; Recurse: boolean;
                            AttrSet, AttrClear: word; lTime: longint);
    procedure RecurseDir(List: TStringList;SourcePath, DestPath, RelPath, Mask: string;
                         var FilesCount: integer; var BytesCount: longint; Action: byte);
    procedure ReadOptions;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function  TForm1.GetVolumeStr(aDrive:string):string;
 begin
  case Drives[aDrive[1]].DriveType of
   dtPortfolio:Result:=UpCase(aDrive[1])+
                       ': ['+
                       Drives[UpCase(aDrive[1])].PFDrive+
                       '] ['+
                       GetVolumeLabel(UpCase(aDrive[1]))+
                       ']';
   else
    Result:=UpCase(aDrive[1])+
            ': ['+
            GetVolumeLabel(UpCase(aDrive[1]))+
            ']';
  end;
 end;

procedure TForm1.SetComboBoxVolume(Index: integer);
 var lItemIndex: integer;
     pomstr: string;
 begin
  pomstr:=GetVolumeStr(ComboBox1.Items.Strings[Index][1]);
  lItemIndex:=ComboBox1.ItemIndex;
  ComboBox1.Items.Strings[Index]:=pomstr;
  ComboBox1.ItemIndex:=lItemIndex;
  lItemIndex:=ComboBox3.ItemIndex;
  ComboBox3.Items.Strings[Index]:=pomstr;
  ComboBox3.ItemIndex:=lItemIndex;
 end;

procedure TForm1.BuildDriveList;
 var cIndex: char;
     sPom: string;
begin
  {rebuild drive combos}
  DetectDrives;
  ComboBox1.Items.Clear;
  ComboBox3.Items.Clear;
  for cIndex:='A' to 'Z' do
   begin
    sPom:='';
    case Drives[cIndex].DriveType of
     dtFloppy   : sPom:=cIndex+': floppy';
     dtFixed    : sPom:=cIndex+': ['+GetVolumeLabel(cIndex)+']';
     dtCDROM    : SPom:=cIndex+': CDROM';
     dtPortfolio: SPom:=cIndex+': ['+
                        Drives[cIndex].PFDrive+'] ['+
                        GetVolumeLabel(cIndex)+']';
    end;
    if sPom<>'' then
     begin
      ComboBox1.Items.Add(sPom);
      ComboBox3.Items.Add(sPom);
     end;
   end;
 end;

procedure TForm1.Msg(Mess:string);
 var PStr:PChar;
 begin
  PStr:=StrAlloc(256);
  StrPCopy(PStr,Mess);
  Application.MessageBox(PStr,'INFO',mb_ok);
  StrDispose(PStr);
 end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 FTIniFile := TIniFile.Create('FTWIN2.INI');
 Application.OnMessage:=AppMessage;
end;

procedure TForm1.FormResize(Sender: TObject);
var i:TPanelType;
begin
 if Vert then
  begin
   LeftPanel.Align:=alTop;
   LeftPanel.Height:=(Form1.ClientHeight-Panel1.Height-BottomPanel.Height) div 2;
  end
 else
  begin
   LeftPanel.Align:=alLeft;
   LeftPanel.Width:=(Form1.Width div 2)-4;
  end;
 CommandComboBox.Width:=(BottomPanel.Width div 3)*2;
 CommandComboBox.Left:=BottomPanel.Width-CommandComboBox.Width-4;
 Label4.Width:=BottomPanel.Width-CommandComboBox.Width-12;
 sb1.Width:=BottomPanel.Width div 5;
 sb2.Width:=BottomPanel.Width div 5;
 sb3.Width:=BottomPanel.Width div 5;
 sb4.Width:=BottomPanel.Width div 5;
 sb5.Width:=BottomPanel.Width - sb1.Width*4;
 sb1.Left:=sb1.Width*0;
 sb2.Left:=sb1.Width*1;
 sb3.Left:=sb1.Width*2;
 sb4.Left:=sb1.Width*3;
 sb5.Left:=sb1.Width*4;
 for i:=ptLeftPanel to ptRightPanel do
  PanelResize(i);
end;

procedure TForm1.FormShow(Sender: TObject);
var i:byte;
    pomstr:string;
begin
 ReadOptions;
 BuildDriveList;
 ActivePanel:=ptLeftPanel;
 LastSelection:='*.*';
 with Panel[ptRightPanel] do
  begin
   Active:=false;
   LastItemIndex:=-1;
   DriveComboBox:=ComboBox3;
   RootButton:=SpeedButton7;
   UpDirButton:=SpeedButton8;
   TopLabel:=Label6;
   BottomLabel:=Label5;
   SizeLabel:=Label7;
   Header:=Header2;
   ListBox:=ListBox2;
   Panel:=Panel4;
   PanelReadFromIni(ptRightPanel);
   PanelRefresh(ptRightPanel);
   PanelActivate(ptRightPanel,false);
  end;
 with Panel[ptLeftPanel] do
  begin
   Active:=true;
   LastItemIndex:=-1;
   DriveComboBox:=ComboBox1;
   RootButton:=SpeedButton3;
   UpDirButton:=SpeedButton1;
   TopLabel:=Label2;
   BottomLabel:=Label3;
   SizeLabel:=Label1;
   Header:=Header1;
   ListBox:=ListBox1;
   Panel:=LeftPanel;
   PanelReadFromIni(ptLeftPanel);
   PanelRefresh(ptLeftPanel);
  end;
 with FTIniFile do
  begin
   Left:= ReadInteger('FORM', 'Left', 200);
   Top:= ReadInteger('FORM', 'Top', 99);
   Width:= ReadInteger('FORM', 'Width', 617);
   Height:= ReadInteger('FORM', 'Height', 447);
   WindowState:=TWindowState(ReadInteger('FORM','State',ord(wsNormal)));
   Vert:=ReadBool('FORM', 'Vert', false);
   VertItem.Checked:=Vert;
   for i:=0 to 9 do
    begin
     pomstr:= ReadString('COMMAND', 'history'+IntToStr(i), '');
     if pomstr<>'' then CommandComboBox.Items.Add(pomstr);
    end;
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var i:TPanelType;
    j:integer;
begin
 with FTIniFile do
  begin
   WriteInteger('FORM', 'Top', Form1.Top);
   WriteInteger('FORM', 'Left', Form1.Left);
   WriteInteger('FORM', 'Width', Form1.Width);
   WriteInteger('FORM', 'Height', Form1.Height);
   WriteInteger('FORM', 'State', ord(Form1.WindowState));
   WriteBool('FORM','Vert',Vert);
   for j:=0 to CommandComboBox.Items.Count do
    WriteString('COMMAND', 'history'+IntToStr(j), CommandComboBox.Items.Strings[j]);
   for i:=ptLeftPanel to ptRightPanel do
    PanelSaveToIni(i);
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 FTIniFile.Free;
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
  if (Sender as TSpeedButton).Name='SpeedButton3' then Panel[ptLeftPanel].ListBox.SetFocus
                                                  else Panel[ptRightPanel].ListBox.SetFocus;

  if Panel[ActivePanel].Path<>'\' then
   begin
    Panel[ActivePanel].Path:='\';
    PanelRefresh(ActivePanel);
   end;
end;

procedure TForm1.Header1Sized(Sender: TObject; ASection, AWidth: Integer);
var i:integer;
begin
 Header1.SectionWidth[ASection]:=AWidth;
 Header2.SectionWidth[ASection]:=AWidth;
 ListBox1.Refresh;
 ListBox2.Refresh;
end;

procedure TForm1.PanelResize(PanelIndex: TPanelType);
 var size: integer;
 begin
  with Panel[PanelIndex] do
   begin
    UpdirButton.Left:=LeftPanel.Width-UpdirButton.Width-4;
    RootButton.Left:=UpdirButton.Left-RootButton.Width;
    if DriveComboBox.Width+4>UpdirButton.Left then
     DriveComboBox.Width:=UpdirButton.Left-8
    else
     DriveComboBox.Width:=150;
    TopLabel.Width:=LeftPanel.Width-8;
    BottomLabel.Width:=LeftPanel.Width-8;
    BottomLabel.Top:=LeftPanel.Height-BottomLabel.Height-4;
    size:=Header.SectionWidth[0]+(LeftPanel.Width-Header.Width-8);
    if size<40 then size:=40;
    Header.Width:=LeftPanel.Width-8;
    Header.SectionWidth[0]:=size;
    ListBox.Width:=LeftPanel.Width-8;
    ListBox.Height:=BottomLabel.Top-ListBox.Top-4;
   end;
 end;

procedure TForm1.PanelReadFromIni(PanelIndex: TPanelType);
 var i:integer;
 begin
  with FTIniFile do
   begin
    Panel[PanelIndex].Drive:= ReadString('PANEL'+IntToStr(Ord(PanelIndex)), 'drive', 'C');
    Panel[PanelIndex].Path:= ReadString('PANEL'+IntToStr(Ord(PanelIndex)), 'path', '\');
    Panel[PanelIndex].Mask:= ReadString('PANEL'+IntToStr(Ord(PanelIndex)), 'mask', '*.*');
    Panel[PanelIndex].Sort:= TSortType(ReadInteger('PANEL'+IntToStr(Ord(PanelIndex)), 'sort', 0));
    Panel[PanelIndex].Style:= TPanelStyle(ReadInteger('PANEL'+IntToStr(Ord(PanelIndex)), 'style', 0));
    Panel[PanelIndex].Header.Width:=ReadInteger('HEADER', 'width',100);
    for i:=0 to Panel[PanelIndex].Header.Sections.Count-2 do
     Panel[PanelIndex].Header.SectionWidth[i]:=0;
    for i:=0 to Panel[PanelIndex].Header.Sections.Count-2 do
     Panel[PanelIndex].Header.SectionWidth[i]:=ReadInteger('HEADER', 'headersection'+IntToStr(i), 10);
  end;
 end;

procedure TForm1.PanelSaveToIni(PanelIndex: TPanelType);
 var i:integer;
 begin
  with FTIniFile do
   begin
    WriteString('PANEL'+IntToStr(Ord(PanelIndex)), 'drive', Panel[PanelIndex].Drive);
    WriteString('PANEL'+IntToStr(Ord(PanelIndex)), 'path', Panel[PanelIndex].Path);
    WriteString('PANEL'+IntToStr(Ord(PanelIndex)), 'mask', Panel[PanelIndex].Mask);
    WriteInteger('PANEL'+IntToStr(Ord(PanelIndex)), 'sort', Ord(Panel[PanelIndex].Sort));
    WriteInteger('PANEL'+IntToStr(Ord(PanelIndex)), 'style', Ord(Panel[PanelIndex].Style));
    WriteInteger('HEADER', 'width',Panel[PanelIndex].Header.Width);
    for i:=0 to Panel[PanelIndex].Header.Sections.Count-1 do
     WriteInteger('HEADER', 'headersection'+IntToStr(i), Panel[PanelIndex].Header.SectionWidth[i]);
   end;
 end;

procedure TForm1.PanelUpdateSL(PanelIndex:TPanelType);
 var DS,DF:longint;

 function MyIntToStr(x: longint):string;
  var i: integer;
      pstr,pstr1: string;
  begin
   pstr:=IntToStr(x);
   pstr1:='';
   for i:=1 to Length(pstr) do
    begin
     if (i>1) and (((i-1) mod 3)=0) then pstr1:=' '+pstr1;
     pstr1:=pstr[Length(pstr)-i+1]+pstr1;
    end;
   MyIntToStr:=pstr1;
  end;

 begin
  GetDiskSizes(Panel[PanelIndex].Drive[1],DS,DF);
  with Panel[PanelIndex] do
   SizeLabel.Caption:=MyIntToStr(DF div 1024)+
                      ' k of '+
                      MyIntToStr(DS div 1024)+
                      ' k free';
 end;

procedure TForm1.PanelUpdateBL(PanelIndex:TPanelType);
 var lStr,lDirStr:string;
     i:integer;
 begin
  with Panel[PanelIndex] do
   begin
    NumSelFiles:=0;
    NumSelDirs:=0;
    KbSel:=0;
    NumFiles:=0;
    NumDirs:=0;
    KbAll:=0;
    with ListBox do
     for i:=0 to Items.Count-1 do
      with TFileRec(Items.Objects[i]) do
       if Name<>'..' then
        if (Attr and faDirectory)>0 then
         begin
          inc(NumDirs);
          if Selected then inc(NumSelDirs);
         end
        else
         begin
          inc(NumFiles);
          inc(KbAll,Size);
          if Selected then
           begin
            inc(NumSelFiles);
            inc(KbSel,Size);
           end;
         end;

    lStr:=IntToStr(KbSel div 1024)+' k / '+IntToStr(KbAll div 1024)+
          ' k in '+IntToStr(NumSelFiles)+' / '+IntToStr(NumFiles)+' files';
    if NumDirs>0 then
     lDirStr:=', '+IntToStr(NumSelDirs)+' / '+IntToStr(NumDirs)+' dir(s)'
    else
     lDirStr:='';
    BottomLabel.Caption:=lStr+lDirStr;
   end;
 end;

procedure TForm1.PanelRefresh(PanelIndex: TPanelType);
 var i,oldindex:integer;
     S: TSearchRec;
     O: TFileRec;
     DosError: integer;

 begin
  with Panel[PanelIndex] do
   begin
    {drive}
    i:=0;
    while i<DriveComboBox.Items.Count do
     if Drive=DriveComboBox.Items.Strings[i][1] then Break
     else Inc(i);
    if i>DriveComboBox.Items.Count-1 then
     begin
      {misto msg -error- vyber jiny disk last disk je v drive combo vyber jiny disk}
      Msg('drive no longer valid');
      i:=1;
      Drive:='C';
      Path:='\';
     end;

    SetComboBoxVolume(i);
    DriveComboBox.ItemIndex:=i;

    {file list}
    ListBox.Items.Clear;
    DosError:=FndFirst(Drive[1]+':'+Path+'*.*',faAnyFile-faVolumeID,S);
    while DosError=0 do
     begin
      O:=TFileRec.Create;
      O.SetValues(S);
      if S.Name<>'.' then
       if ((O.Attr and faDirectory)>0) or WildcardMatch(O.GetName,Mask) then
        ListBox.Items.AddObject(O.GetString(Sort),O)
       else
        O.Free;
      DosError:=FndNext(S);
     end;
    FndClose(S);

    {pakarna s itemindex a setfocus}
    if ListBox.Items.Count>0 then ListBox.ItemIndex:=0;
    LastItemIndex:=0;
    {ListBox.SetFocus;}

    LastClicked:=-1;

    {labels}
    Label4.Caption:=LowerCase(Drive[1]+':'+Path+'>');
    TopLabel.Caption:=LowerCase(Drive[1]+':'+Path+Mask);
    PanelUpdateBL(PanelIndex);
    PanelUpdateSL(PanelIndex);
   end;

 end;

procedure TForm1.PanelActivate(PanelIndex: TPanelType; Act:boolean);
 begin
  if Act then
   with Panel[PanelIndex] do
    begin
     TopLabel.Color:=clHighlight;
     TopLabel.Font.Color:=clWindow;
     Label4.Caption:=LowerCase(Drive[1]+':'+Path+'>');
     Active:=true;
     TopLabel.Width:=LeftPanel.Width-8;
     ListBox.ItemIndex:=LastItemIndex;
     Name1.Checked:=false;
     Extension1.Checked:=false;
     Time1.Checked:=false;
     Size1.Checked:=false;
     case Sort of
      stName: Name1.Checked:=true;
      stExt : Extension1.Checked:=true;
      stTime: Time1.Checked:=true;
      stSize: Size1.Checked:=true;
     end;
     if Style=psFull then
      begin
       Brief1.Checked:=false;
       Full1.Checked:=true;
      end
     else
      begin
       Brief1.Checked:=true;
       Full1.Checked:=false;
      end;
     UpdateMaskMenu(Mask,Mask='*.*');
     end
  else
   with Panel[PanelIndex] do
    begin
     TopLabel.Color:=clBtnFace;
     TopLabel.Font.Color:=clWindowText;
     Active:=false;
     TopLabel.Width:=LeftPanel.Width-8;
     LastItemIndex:=ListBox.ItemIndex;
     ListBox.ItemIndex:=-1;
   end;
 end;

procedure TForm1.ListBox1DrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var offset:integer;
begin
 {listbox owner draw}
  with (Control as TListBox) do
   begin
    if TFileRec(Items.Objects[Index]).Selected then
     Canvas.Font.Color:=clRed
    else
     {if (odFocused in State) or (odSelected in State) then
      Canvas.Font.Color:=clWhite
     else}
      Canvas.Font.Color:=clBlack;
    offset:=0;
    Canvas.Brush.Color:=clWindow;
    Canvas.FillRect(Rect);
    Canvas.TextOut(Rect.Left+2+offset,Rect.Top,TFileRec(Items.Objects[Index]).GetNameStr);
    inc(offset,Header1.SectionWidth[0]);
    Canvas.TextOut(Rect.Left+2+offset,Rect.Top,LowerCase(TFileRec(Items.Objects[Index]).GetExtStr));
    if Columns=0 then
     begin
      inc(offset,Header1.SectionWidth[1]);
      inc(offset,Header1.SectionWidth[2]);
      Canvas.TextOut(Rect.Left-4+offset-Canvas.TextWidth(TFileRec(Items.Objects[Index]).GetSizeStr),
       Rect.Top,TFileRec(Items.Objects[Index]).GetSizeStr);
      Canvas.TextOut(Rect.Left+2+offset,Rect.Top,TFileRec(Items.Objects[Index]).GetTimeStr);
      inc(offset,Header1.SectionWidth[3]);
      Canvas.TextOut(Rect.Left+2+offset,Rect.Top,TFileRec(Items.Objects[Index]).GetAtribStr);
     end;
   end;
end;

procedure TForm1.ComboBox1DrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
  Bitmap: TBitmap;
  bmpWidth: Integer;
  PStr:PCHar;
begin
  with (Control as TComboBox).Canvas do
  begin
    FillRect(Rect);
    bmpWidth  := 16;
    case Drives[(Control as TComboBox).Items.Strings[Index][1]].DriveType of
     dtFloppy   : Bitmap:=Image1.Picture.Bitmap;
     dtFixed    : Bitmap:=Image2.Picture.Bitmap;
     dtNetwork  : Bitmap:=Image3.Picture.Bitmap;
     dtCDROM    : Bitmap:=Image4.Picture.Bitmap;
     dtRAM      : Bitmap:=Image5.Picture.Bitmap;
     dtPortfolio: Bitmap:=Image6.Picture.Bitmap;
     else
      Bitmap:=nil;
    end;
    if Bitmap <> nil then
    begin
      bmpWidth := Bitmap.Width;
      BrushCopy(Bounds(Rect.Left + 2,
               (Rect.Top + Rect.Bottom - Bitmap.Height) div 2,
               Bitmap.Width, Bitmap.Height),
               Bitmap, Bounds(0, 0, Bitmap.Width, Bitmap.Height),
               Bitmap.Canvas.Pixels[0, 0]);
    end;
    PStr:=StrAlloc(256);
    StrPCopy(PStr,(Control as TComboBox).Items.Strings[Index]);
    Rect.Left := Rect.Left + bmpWidth + 6;
    DrawText(Handle, PStr, -1, Rect,
             DT_SINGLELINE or DT_VCENTER or DT_NOPREFIX);
    StrDispose(PStr);
  end;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
 Close;
end;

procedure TForm1.GoUpdir;
var i:integer;
    pomstr:string;

begin
 with Panel[ActivePanel] do
  begin
   if Path='\' then Exit;
   i:=Length(Path)-1;
   while Path[i]<>'\' do
    dec(i);
   pomstr:=Copy(Path,i+1,Length(Path)-i-1);
   Path:=Copy(Path,1,i);
   PanelRefresh(ActivePanel);
   i:=0;
   with ListBox.Items do
    while ((Objects[i] as TFileRec).GetName<>pomstr) and (i<Count) do
     inc(i);
   ListBox.ItemIndex:=i;
  end;
end;

procedure TForm1.SpeedButton8Click(Sender: TObject);
begin
 {navrat o adresar zpet}
 if (Sender as TSpeedButton).Name='SpeedButton1' then Panel[ptLeftPanel].ListBox.SetFocus
                                                 else Panel[ptRightPanel].ListBox.SetFocus;
 GoUpdir;
end;

procedure TForm1.ListBox1DblClick(Sender: TObject);
var FileRec: TFileRec;
begin
 Timer1.Enabled:=False;
 {dblclick on directory}
  with Panel[ActivePanel] do
  if (Listbox.ItemIndex>-1) and (ListBox.Items.Count>0) then
   begin
    FileRec:=TFileRec(ListBox.Items.Objects[Listbox.ItemIndex]);
    if (FileRec.GetName='..') then
     GoUpdir
    else
     if ((FileRec.Attr and faDirectory)>0) then
      begin
       Path:=Path+FileRec.GetName+'\';
       PanelRefresh(ActivePanel);
      end
     else
      ShellExec;
   end;
 end;

procedure TForm1.ListBox1KeyPress(Sender: TObject; var Key: Char);
begin
 if Key=#13 then ListBox1DblClick(Sender);
end;

procedure TForm1.ListBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var O:TFileRec;
begin
 if (UpCase(chr(Key))='R') and (ssCtrl in Shift) then SpeedButton4Click(Self);
 if Key=vk_Space then
  begin
   (Panel[ActivePanel].ListBox.Items.Objects[Panel[ActivePanel].ListBox.ItemIndex] as TFileRec).Selected:=
   not (Panel[ActivePanel].ListBox.Items.Objects[Panel[ActivePanel].ListBox.ItemIndex] as TFileRec).Selected;
   Panel[ActivePanel].ListBox.Refresh;
   PanelUpdateBL(ActivePanel);
  end;
 if Key=vk_Insert then
  begin
   (Panel[ActivePanel].ListBox.Items.Objects[Panel[ActivePanel].ListBox.ItemIndex] as TFileRec).Selected:=
   not (Panel[ActivePanel].ListBox.Items.Objects[Panel[ActivePanel].ListBox.ItemIndex] as TFileRec).Selected;
   Panel[ActivePanel].ListBox.Refresh;
   if Panel[ActivePanel].ListBox.ItemIndex<Panel[ActivePanel].ListBox.Items.Count-1 then
    Panel[ActivePanel].ListBox.ItemIndex:=Panel[ActivePanel].ListBox.ItemIndex+1;
   Panel[ActivePanel].ListBox.Refresh;
   PanelUpdateBL(ActivePanel);
  end;
 if (Key=vk_F1) and (ssAlt in Shift) then
  begin
   SendMessage(ComboBox1.Handle,CB_SHOWDROPDOWN,1,0);
   ComboBox1.SetFocus;
 end;
 if (Key=vk_F2) and (ssAlt in Shift) then
  begin
   SendMessage(ComboBox3.Handle,CB_SHOWDROPDOWN,1,0);
   ComboBox3.SetFocus;
  end;
 if (Key=vk_Return) and (ssCtrl in Shift) and ((Sender as TListBox).ItemIndex>-1) then
  begin
   if ssShift in Shift then
    CommandComboBox.Text:=CommandComboBox.Text+
                          LowerCase(Panel[ActivePanel].Drive[1])+
                          ':'+
                          LowerCase(Panel[ActivePanel].Path)+
                          TFileRec((Sender as TListBox).Items.Objects[(Sender as TListBox).ItemIndex]).GetName+
                          ' '
   else
    CommandComboBox.Text:=CommandComboBox.Text+
                          TFileRec((Sender as TListBox).Items.Objects[(Sender as TListBox).ItemIndex]).GetName+
                          ' ';
   end;
 end;

procedure TForm1.ComboBox1Exit(Sender: TObject);
begin
 listbox1exit(sender);
 if cb1oldvalue<>combobox1.itemindex then
  with Panel[ActivePanel] do
   begin
    Drive:=DriveComboBox.Items.Strings[DriveComboBox.ItemIndex][1];
    Path:='\';
    PostMessage(Handle, WM_PANELREFRESH, 0,0);
    ListBox1.SetFocus;
   end;
end;

procedure TForm1.CommandComboBoxExit(Sender: TObject);
begin
 with Sender as TComboBox do
 if Items.IndexOf(Text)<0 then
  Items.Insert(0,Text);
end;

procedure TForm1.Newfolder1Click(Sender: TObject);
var i:word;
    pomstr:string;
begin
 FormNewDir:=TFormNewDir.Create(Form1);
 if FormNewDir.ShowModal=mrOK then
  begin
   pomstr:=LowerCase(FormNewDir.Edit.Text);
   try
    with Panel[ActivePanel] do
    MakeDirectory(Drive+':'+Path+pomstr);
    PanelRefresh(ActivePanel);
    i:=0;
    with Panel[ActivePanel].ListBox.Items do
     begin
      while ((Objects[i] as TFileRec).GetName<>pomstr) and (i<Count) do
       inc(i);
      if i<Count then Panel[ActivePanel].ListBox.ItemIndex:=i
      else if Count=0 then Panel[ActivePanel].ListBox.ItemIndex:=-1
      else Panel[ActivePanel].ListBox.ItemIndex:=0;
     end;
    except
     Msg('Cannot create directory');
    end;
  end;
 FormNewDir.Free;
end;

procedure TForm1.VertItemClick(Sender: TObject);
begin
 Vert:=not Vert;
 VertItem.Checked:=Vert;
 FormResize(Self);
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
var dropstate:longint;
begin
 dropstate:=SendMessage(ComboBox1.Handle,CB_GETDROPPEDSTATE,0,0);
 if dropstate=0 then
  listbox1.setfocus;
end;

procedure TForm1.Volumelabel1Click(Sender: TObject);
var OldLabel:TVolumeLabel;
begin
 {set volume}
 with Panel[ActivePanel] do
  begin
   FormNewLabel:=TFormNewLabel.Create(Form1);
   OldLabel:=GetVolumeLabel(Drive[1]);
   FormNewLabel.LabelEdit.Text:=OldLabel;
   FormNewLabel.Left:=Form1.Left+Panel.Left+(Panel.Width-FormNewLabel.Width) div 2;
   FormNewLabel.Top:=Form1.Top+Panel.Top+(Panel.Height-FormNewLabel.Height) div 2;
   if (FormNewLabel.ShowModal=mrOK) and (FormNewLabel.LabelEdit.Text<>OldLabel) then
    begin
     SetVolumeLabel(FormNewLabel.LabelEdit.Text, Drive[1]);
     PanelRefresh(ActivePanel);
    end;
   FormNewLabel.Free;
  end;
end;

procedure TForm1.Synchronizesystemdatetime1Click(Sender: TObject);
var DateTime: TDateTime;
begin
 DateTime:=Now;
 FormSysDate:= TFormSysDate.Create(Form1);
 with FormSysDate do
  begin
   DateEdit.Text:=DateToStr(DateTime);
   TimeEdit.Text:=TimeToStr(DateTime);
   if ShowModal=mrOK then
    begin
     DateTime:=StrToDateTime(DateEdit.Text+' '+TimeEdit.Text);
     SetSysDateTime(DateTime);
    end;
   Free;
  end;
end;

procedure TForm1.Name1Click(Sender: TObject);
begin
 Panel[ActivePanel].Sort:=stName;
 PanelRefresh(ActivePanel);
end;

procedure TForm1.Extension1Click(Sender: TObject);
begin
 Panel[ActivePanel].Sort:=stExt;
 PanelRefresh(ActivePanel);
 PanelActivate(ActivePanel, true);
end;

procedure TForm1.Time1Click(Sender: TObject);
begin
 Panel[ActivePanel].Sort:=stTime;
 PanelRefresh(ActivePanel);
 PanelActivate(ActivePanel, true);
end;

procedure TForm1.Size1Click(Sender: TObject);
begin
 Panel[ActivePanel].Sort:=stSize;
 PanelRefresh(ActivePanel);
 PanelActivate(ActivePanel, true);
end;

procedure TForm1.NotImplemented(Sender: TObject);
begin
 Msg('Not implemented.');
end;

procedure TForm1.SelectAction(Action: TSelAction);
 var i:integer;
 begin
  with Panel[ActivePanel].ListBox do
  begin
   for i:=0 to Items.Count-1 do
    begin
     case Action of
      saSelect:  (Items.Objects[i] as TFileRec).Selected:=true;
      saUnselect:(Items.Objects[i] as TFileRec).Selected:=false;
      saInvert:  (Items.Objects[i] as TFileRec).Selected:=not (Items.Objects[i] as TFileRec).Selected;
     end;
    end;
   Refresh;
   PanelUpdateBL(ActivePanel);
  end;
 end;

procedure TForm1.Selectall1Click(Sender: TObject);
begin
 SelectAction(saSelect);
end;

procedure TForm1.Unselect1Click(Sender: TObject);
begin
 SelectAction(saUnselect);
end;

procedure TForm1.Invertselection1Click(Sender: TObject);
begin
 SelectAction(saInvert);
end;

procedure TForm1.ListBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);

var
  Value: Integer;
  APoint: TPoint;
begin
 Timer1.Enabled:=False;
 GetCursorPos(APoint);
 APoint:=(Sender as TListBox).ScreenToClient(APoint);
 Value := (Sender as TListBox).ItemAtPos(APoint, True);
 if (Button=mbLeft) and (LastClicked>-1) and (LastClicked=Value) and not (ssDouble in Shift) then
  Timer1.Enabled:=True
 else
  begin
   if not (ssDouble in Shift) then LastClicked:=Value
                              else LastClicked:=-1;
   with Sender as TListBox do
    if (Value>-1) and (Button=mbRight) then
     begin
      SetFocus;
      ItemIndex:=Value;
      (Items.Objects[Value] as TFileRec).Selected:=not(Items.Objects[Value] as TFileRec).Selected;
      Refresh;
      PanelUpdateBL(ActivePanel);
     end;
  end;
end;

procedure TForm1.SelectGroup(Select: boolean);
var i:byte;
    pomstr:string;
begin
 FormMask:= TFormMask.Create(Form1);
 with FormMask do
  begin
   with Panel[ActivePanel] do
    begin
     Left:=Form1.Left+Panel.Left+(Panel.Width-Width) div 2;
     Top:=Form1.Top+Panel.Top+(Panel.Height-Height) div 2;
    end;
   MaskComboBox.Items.Clear;
   if Select then GroupBox.Caption:='&Select group'
             else GroupBox.Caption:='&Unselect group';
   for i:=0 to 9 do
    begin
     pomstr:= FTIniFile.ReadString('MASK', 'history'+IntToStr(i), '');
     if pomstr<>'' then MaskComboBox.Items.Add(pomstr);
    end;
   MaskComboBox.Text:=LastSelection;
   if ShowModal=mrOK then
    begin
     LastSelection:=MaskComboBox.Text;
     with Panel[ActivePanel] do
      for i:=0 to ListBox.Items.Count-1 do
       with (ListBox.Items.Objects[i] as TFileRec) do
        if WildcardMatch(GetName,LastSelection) then Selected:=Select
        else Selected:=not Select;
     for i:=0 to MaskComboBox.Items.Count-1 do
      FTIniFile.WriteString('MASK', 'history'+IntToStr(i), MaskComboBox.Items.Strings[i]);
     Panel[ActivePanel].ListBox.Refresh;
    end;
   Free;
  end;
end;

procedure TForm1.Selectgroup1Click(Sender: TObject);
begin
 SelectGroup(True);
end;

procedure TForm1.Unselectgroup1Click(Sender: TObject);
begin
 SelectGroup(False);
end;

procedure TForm1.RunDOS1Click(Sender: TObject);
begin
 ShellExecute(Handle,nil,'command.com',nil,nil,SW_SHOWMAXIMIZED);
end;

function StripSpaces(s: string):string;
 var ps:string;
 begin
  ps:=s;
  while (Length(ps)>0) and (ps[1]=' ') do
   Delete(ps,1,1);
  while (Length(ps)>0) and (ps[Length(ps)]=' ') do
   Delete(ps,Length(ps),1);
  StripSpaces:=ps;
 end;

function NormalizePath(s: string):string;
 var i:integer;
     List: TStringList;
     ps: string;
 begin
  if (s='') or (Length(s)<3) then
   begin
    NormalizePath:=s;
    Exit;
   end;
  i:=2;
  ps:='';
  List:=TStringList.Create;
  while i<=Length(s) do
   begin
    if s[i]='\' then
     begin
      if ps<>'.' then
       if ps='..' then
        begin
         if List.Count>0 then List.Delete(List.Count-1);
         ps:='';
        end
       else
        begin
         List.Add(ps);
         ps:='';
        end;
     end
    else
     ps:=ps+s[i];
    inc(i);
   end;
  ps:='\';
  i:=0;
  while i<List.Count do
   begin
    ps:=ps+List.Strings[i]+'\';
    inc(i);
   end;
  List.Free;
  NormalizePath:=ps;
 end;

procedure TForm1.ShellExec;
var s, lDrive, lPath, lCmd, lParams: string;
    PStr, PStr1: PChar;
    i: byte;
    H: THandle;
    FR: TFileRec;
begin
 lDrive:='';
 lPath:='';
 lCmd:='';
 lParams:='';
 PStr:=StrAlloc(255);
 with Panel[ActivePanel] do
  if CommandComboBox.Text='' then
   s:=Drive+':'+
      Path+
      (ListBox.Items.Objects[ListBox.ItemIndex] as TFileRec).GetName
   else
    s:=CommandComboBox.Text;
 s:=StripSpaces(s);
 {extract drive}
 if (Length(s)>=2) and (s[2]=':') then
  begin
   lDrive:=Copy(s,1,2);
   Delete(s,1,2);
  end;
 {extract params}
 while Pos(' ',s)>0 do
  begin
   while s[Length(s)]<>' ' do
    begin
     lParams:=s[Length(s)]+lParams;
     Delete(s,Length(s),1);
    end;
   lParams:=' '+lParams;
   Delete(s,Length(s),1);
  end;
  lParams:=StripSpaces(lParams);
 {split cmd path}
 while (Length(s)>0) and (s[Length(s)]<>'\') do
  begin
   lCmd:=s[Length(s)]+lCmd;
   Delete(s,Length(s),1);
  end;
 lPath:=s;
 if (lDrive<>'') and (lPath='') then
  begin
  end
 else
  begin
   if lPath<>'' then
    begin
     if lPath[1]<>'\' then
      with Panel[ActivePanel] do
       lPath:=Path+lPath;
    end
   else
    with Panel[ActivePanel] do
     lPath:=Path;
  end;

 {process change drive}
 with Panel[ActivePanel] do
  if lDrive='' then lDrive:=Drive+':';

 {normalize path}
 lPath:=NormalizePath(lPath);

 {process dos command}

 {if  pf then}
 { pffindexecutable}

 StrPCopy(PStr,lDrive+lPath+lCmd);
 if Drives[UpCase(lDrive[1])].DriveType=dtPortfolio then
  begin
   {pfFindExecutable}
   FR:=TFileRec.Create;
   FR.Name:=lCmd;
   FR.SplitNameExt;
   lDrive:=Drives[UpCase(lDrive[1])].PFDrive+':';
   PFForm.PFExec(lDrive+lPath+FR.GetName+' '+lParams);
   FR.Free;
  end
 else
  begin
   PStr1:=StrAlloc(255);
   StrPCopy(PStr1,lParams);
   H:=ShellExecute(Handle,nil,PStr,PStr1,nil,SW_SHOW);
   StrDispose(PStr1);
   if H<=32 then
    Msg('Shell execute error: '+IntToStr(H));
  end;
  StrDispose(PStr);
end;

procedure TForm1.CommandComboBoxKeyPress(Sender: TObject; var Key: Char);
begin
 if Key=#13 then CommandComboBoxDblClick(Sender);
end;

procedure TForm1.CommandComboBoxDblClick(Sender: TObject);
begin
 if CommandComboBox.Text<>'' then ShellExec;
end;

procedure TForm1.AllFilesItemClick(Sender: TObject);
begin
 {all files}
 with Panel[ActivePanel] do
  begin
   Mask:='*.*';
   UpdateMaskMenu(Mask,true);
  end;
 PanelRefresh(ActivePanel);
end;

procedure TForm1.MaskItemClick(Sender: TObject);
begin
 {click zvolene masce}
 with Panel[ActivePanel] do
   begin
    Mask:=MaskItem.Caption;
    UpdateMaskMenu(Mask,Mask='*.*');
   end;
 PanelRefresh(ActivePanel);
end;

procedure TForm1.Custom1Click(Sender: TObject);
var i:byte;
    pomstr:string;
begin
 FormMask:= TFormMask.Create(Form1);
 with FormMask do
  begin
   with Panel[ActivePanel] do
    begin
     Left:=Form1.Left+(Form1.Width-Width) div 2;
     Top:=Form1.Top+(Form1.Height-Height) div 2;
    end;
   MaskComboBox.Items.Clear;
   GroupBox.Caption:='&Select mask';
   for i:=0 to 9 do
    begin
     pomstr:= FTIniFile.ReadString('MASK', 'history'+IntToStr(i), '');
     if pomstr<>'' then MaskComboBox.Items.Add(pomstr);
    end;
   MaskComboBox.Text:=Panel[ActivePanel].Mask;
   if ShowModal=mrOK then
    begin
     Panel[ActivePanel].Mask:=MaskComboBox.Text;
     PanelRefresh(ActivePanel);
     for i:=0 to MaskComboBox.Items.Count-1 do
      FTIniFile.WriteString('MASK', 'history'+IntToStr(i), MaskComboBox.Items.Strings[i]);
     UpdateMaskMenu(Panel[ActivePanel].Mask,false);
    end;
   Free;
  end;
end;

procedure TForm1.UpdateMaskMenu(Mask: string; AllFiles: boolean);
 begin
  if AllFiles then
   begin
    MaskItem.Checked:=false;
    ProgramsItem.Checked:=false;
    AllFilesItem.Checked:=true;
   end
  else
   begin
    if Mask='*.*' then
     begin
      MaskItem.Checked:=false;
      ProgramsItem.Checked:=false;
      AllFilesItem.Checked:=true;
     end;
    if Mask='*.exe;*.com;*.bat' then
     begin
      MaskItem.Checked:=false;
      ProgramsItem.Checked:=true;
      AllFilesItem.Checked:=false;
     end
    else
     begin
      MaskItem.Checked:=true;
      ProgramsItem.Checked:=false;
      AllFilesItem.Checked:=false;
      MaskItem.Caption:=Mask;
     end;
   end;
 end;

procedure TForm1.Networkconnections1Click(Sender: TObject);
begin
 NetConnectDialog1.Execute;
end;

procedure TForm1.DisconnectNetworkDrives1Click(Sender: TObject);
begin
 NetDisconnectDialog1.Execute;
end;

procedure TForm1.ShareCurrentDirectory1Click(Sender: TObject);
var pomstr:string;
begin
 with Panel[ActivePanel] do
  if Drives[Drive[1]].DriveType<>dtPortfolio then
   begin
    pomstr:=Drive[1]+':'+Path;
    dec(pomstr[0]);
    NetShareAsDialog1.PathName:=pomstr;
    NetShareAsDialog1.Execute;
   end
  else
   Msg('Cannot share Atari Portfolio drive.');
end;

procedure TForm1.UnshareDirectory1Click(Sender: TObject);
begin
 with Panel[ActivePanel] do
  NetStopShareDialog1.PathName:=Drive[1]+':'+Path;
 NetStopShareDialog1.Execute;
end;

procedure TForm1.InPlaceEditGoingOff(Sender: TObject;
  Reason: TGoingOffReason; Value: String; var AllowExit: Boolean);
var
  i,t: Integer;
  NewName,
  OldName:string;
begin
 if reason = goEnter then
  with (Sender as TInEdit).Parent as TListBox do
   begin
    i := ItemIndex;
    t := TopIndex;
    try
     with Panel[ActivePanel] do
      begin
       NewName:=Drive+':'+Path+Value;
       OldName:=Drive+':'+Path+(Items.Objects[LastClicked] as TFileRec).GetName;
       if UpperCase(OldName)<>UpperCase(NewName) then
        begin
         RnmFile(OldName,NewName);
         PanelRefresh(ActivePanel);
        end;
      end;
    finally
    ;
    end;
    ItemIndex := i;
    TopIndex := t;
   end;

 with (Sender as TInEdit).Parent as TListBox do
  if (reason = goUp) or (reason = goLeft) then
      PostMessage(Handle, WM_KEYDOWN, VK_UP, 0)
  else if (reason = goDown) or (reason = goRight) then
      PostMessage(Handle, WM_KEYDOWN, VK_DOWN, 0)
  else if (reason = goHome) then
      PostMessage(Handle, WM_KEYDOWN, VK_HOME, 0)
  else if (reason = goEnd) then
      PostMessage(Handle, WM_KEYDOWN, VK_END, 0)
  else if (reason = goPgUp) then
      PostMessage(Handle, WM_KEYDOWN, VK_PRIOR, 0)
  else if (reason = goPgDn) then
      PostMessage(Handle, WM_KEYDOWN, VK_NEXT, 0);

  AllowExit:=true;
  LastClicked:=-1;
end;

function TForm1.DoAction(SourcePath,DestPath: string; FileRec: TFileRec;
                         AttrSet, AttrClear: word; lTime: longint):integer;
 var i:integer;
 begin
  {kdybych pridaval a odstranoval filerec nemusel bych refresh}
  Result:=0;
  with FileRec do
   begin
    if (Action and acCopy)>0 then Result:=FmBatchProcess.CopyFile(FileRec, SourcePath, DestPath);
    if (Action and acMove)>0 then Result:=FmBatchProcess.MoveFile(FileRec, SourcePath, DestPath);
    if (Action and acDelete)>0 then Result:=FmBatchProcess.DeleteFile(FileRec,SourcePath);
    if (Action and acSetAttr)>0 then Result:=FmBatchProcess.SetAttribFile(FileRec,SourcePath, AttrSet,AttrClear,lTime);
    if (Action and acMkDir)>0 then Result:=FmBatchProcess.MakeDir(FileRec,DestPath);
    if (Action and acRmDir)>0 then Result:=FmBatchProcess.RemoveDir(FileRec,SourcePath);
    if (Action and acUnselect)>0 then
     with Panel[ActivePanel] do
      begin
       i:=0;
       while (i<ListBox.Items.Count) and ((ListBox.Items.Objects[i] as TFileRec).GetName<>GetName) do
        inc(i);
       (ListBox.Items.Objects[i] as TFileRec).Selected:=false;
       ListBox.Refresh;
      end;
   end;
 end;

 procedure TForm1.RecurseDir(List: TStringList;SourcePath, DestPath, RelPath, Mask: string;
                              var FilesCount: integer; var BytesCount: longint; Action: byte);
 var i: word;
    LFiles: TStringList;
    S: TSearchRec;
    O: TFileRec;
    DosError: integer;
 begin
   DosError:=FndFirstU(SourcePath+RelPath+Mask,faAnyFile-faVolumeID,S);
   while DosError=0 do
    begin
     O:=TFileRec.Create;
     O.SetValues(S);
     if (S.Name<>'.') and (S.Name<>'..') then
      if (O.Attr and faDirectory)>0 then
       begin
        if (Action=acCopy) or (Action=acMove) then
         begin
          O.Action:=acMkDir;
          List.AddObject(RelPath, O);
         end;
        RecurseDir(List,SourcePath,DestPath,RelPath+O.GetName+'\',Mask,FilesCount,BytesCount,Action);
        if Action=acDelete then
         begin
          O.Action:=acRmDir;
          List.AddObject(RelPath, O);
         end;
        if Action=acMove then
         begin
          O:=TFileRec.Create;
          O.SetValues(S);
          O.Action:=acRmDir;
          List.AddObject(RelPath, O);
         end;
       end
      else
       if WildcardMatch(O.GetName,Mask) then
        begin
         O.Action:=Action;
         List.AddObject(RelPath, O);
         inc(FilesCount);
         inc(BytesCount,O.Size);
        end
       else
        O.Free;
     DosError:=FndNextU(S);
    end;
   FndClose(S);
  end;

procedure TForm1.DoBatchAction(Act: byte; Recurse: boolean;
                               AttrSet, AttrClear: word; lTime: longint);
 var PStr:PChar;
     i:integer;
     PT:TPanelType;
     List: TStringList;
     FilesCount: integer;
     BytesCount: longint;
     O: TFileRec;
     DestPath: string;
     Confirm: boolean;

 begin
  i:=Panel[ActivePanel].NumSelDirs+Panel[ActivePanel].NumSelFiles;
  if i=0 then
   begin
    with Panel[ActivePanel].ListBox do
     begin
       if (Items.Count=0) or ((Items.Objects[ItemIndex] as TFileRec).GetName='..') then
        begin
         Application.MessageBox('No files selected!','Atari Portfolio Manager',mb_ok+mb_iconexclamation);
         Exit;
        end;
      (Items.Objects[ItemIndex] as TFileRec).Selected:=true;
     end;
    PanelUpdateBL(ActivePanel);
    i:=1;
   end;
  PStr:=StrAlloc(256);
  List:=TStringList.Create;
  if ActivePanel=ptLeftPanel then
   PT:=ptRightPanel
  else
   PT:=ptLeftPanel;
  DestPath:=Panel[PT].Drive+':'+Panel[PT].Path;
  case Act of
   acCopy:
    StrPCopy(PStr,'Copy '+IntToStr(i)+' file(s) from'+#13+
                  Panel[ActivePanel].Drive+':'+Panel[ActivePanel].Path+
                  Panel[ActivePanel].Mask+#13+
                  'to'+#13+
                  DestPath+'*.*');
   acMove:
    StrPCopy(PStr,'Move '+IntToStr(i)+' file(s) from'+#13+
                  Panel[ActivePanel].Drive+':'+Panel[ActivePanel].Path+
                  Panel[ActivePanel].Mask+#13+
                  'to'+#13+
                  DestPath+'*.*');
   acDelete:
    StrPCopy(PStr,'Delete '+IntToStr(i)+' file(s)/dir(s)');
  end;
  if Act=acSetAttr then Confirm:=true
                   else Confirm:=Application.MessageBox(PStr,'Atari Portfolio Manager',mb_okcancel)=id_ok;
  if Confirm then
   begin
    FmBatchProcess:=TFmBatchProcess.Create(Form1);
    FmBatchProcess.SetupWindow(Act);
    FmBatchProcess.Show;
    with Panel[ActivePanel] do
     begin
      FilesCount:=0;
      BytesCount:=0;
      for i:=0 to ListBox.Items.Count-1 do
       with ListBox.Items.Objects[i] as TFileRec do
        if Selected and (Name='..') then
         begin
          O:=TFileRec.Create;
          O.Name:=Name;
          O.Ext:=Ext;
          O.Attr:=Attr;
          O.Size:=Size;
          O.Time:=Time;
          O.Action:=acUnselect;
          List.AddObject('',O);
         end
        else
        if Selected and (Name<>'..') then
         begin
          O:=TFileRec.Create;
          O.Name:=Name;
          O.Ext:=Ext;
          O.Attr:=Attr;
          O.Size:=Size;
          O.Time:=Time;
          if (Attr and faDirectory)>0 then
           begin
            if Act=acSetAttr then
             begin
              O.Action:=Act;
              List.AddObject('',O);
             end;
            if (Act=acCopy) or (Act=acMove) then
             begin
              O.Action:=acMkDir;
              List.AddObject('',O);
             end;
            if Recurse then RecurseDir(List,Drive+':'+Path,DestPath,GetName+'\',Mask,FilesCount,BytesCount,Act);
            if Act=acDelete then
             begin
              O.Action:=acRmDir;
              List.AddObject('', O);
             end;
            O:=TFileRec.Create;
            O.Name:=Name;
            O.Ext:=Ext;
            O.Attr:=Attr;
            O.Size:=Size;
            O.Time:=Time;
            if Act=acMove then
             O.Action:=acRmDir+acUnselect
            else
             O.Action:=acUnselect;
            List.AddObject('',O);
           end
          else
           begin
            O.Action:=Act+acUnselect;
            List.AddObject('',O);
            inc(FilesCount);
            inc(BytesCount,Size);
           end;
         end;
      FmBatchProcess.FilesCount:=FilesCount;
      FmBatchProcess.BytesCount:=BytesCount;
      i:=0;
      while (i<List.Count)
       and (DoAction(Drive+':'+Path+List.Strings[i],
                     DestPath+List.Strings[i],
                     List.Objects[i] as TFileRec, AttrSet, AttrClear, lTime)>-1) do
       inc(i);
     end;
    FmBatchProcess.Close;
    FmBatchProcess.Free;
    if (Act=acCopy) or (Act=acMove) then
     begin
      PanelRefresh(PT);
      PanelActivate(PT,false);
     end;
    if (Act=acDelete) or (Act=acMove) or (Act=acSetAttr) then
     begin
      Panel[ActivePanel].ListBox.SetFocus;
      PanelRefresh(ActivePanel);
     end
    else
     begin
      PanelUpdateBL(ActivePanel);
     end;
   end;
  List.Free;
  StrDispose(PStr);
 end;

procedure TForm1.Copyfiles1Click(Sender: TObject);
begin
 DoBatchAction(acCopy, true, 0, 0, 0);
end;

procedure TForm1.MoveRename1Click(Sender: TObject);
begin
 DoBatchAction(acMove, true, 0, 0, 0);
end;

procedure TForm1.Delete1Click(Sender: TObject);
begin
 DoBatchAction(acDelete, true, 0, 0, 0);
end;

procedure TForm1.Changeatributes1Click(Sender: TObject);
var Action: byte;
    FileRec: TFileRec;
    i: word;
    DateTime: TDateTime;
    lAttr: word;
    lFileDate: longint;
    lAttrSet,lAttrClear: word;
    lRecurse: boolean;
begin
 FmSetAttr:=TFmSetAttr.Create(Form1);

 with Panel[ActivePanel] do
  if (NumSelFiles=0) and (NumSelDirs=0) then
   if ListBox.ItemIndex<0 then
    Action:=0
   else
    if (ListBox.Items.Objects[ListBox.ItemIndex] as TFileRec).GetName='..' then
     Action:=0
    else
     if ((ListBox.Items.Objects[ListBox.ItemIndex] as TFileRec).Attr and faDirectory)>0
      then
       begin
        (ListBox.Items.Objects[ListBox.ItemIndex] as TFileRec).Selected:=true;
        Action:=2;
       end
      else
       begin
        Action:=1;
        (ListBox.Items.Objects[ListBox.ItemIndex] as TFileRec).Selected:=true;
        FileRec:=ListBox.Items.Objects[ListBox.ItemIndex] as TFileRec;
       end
  else
   if (NumSelFiles=1) and (NumSelDirs=0) then
    begin
     Action:=1;
     i:=0;
     while not (ListBox.Items.Objects[i] as TFileRec).Selected do
      inc(i);
     FileRec:=ListBox.Items.Objects[i] as TFileRec;
    end
   else
    Action:=2;

 case Action of
  0: Msg('No files selected.');
  1: begin
      with FileRec do
       begin
        FmSetAttr.CBReadOnly.AllowGrayed:=false;
        FmSetAttr.CBArchive.AllowGrayed:=false;
        FmSetAttr.CBHidden.AllowGrayed:=false;
        FmSetAttr.CBSysFile.AllowGrayed:=false;
        if (Attr and faReadOnly)>0 then FmSetAttr.CBReadOnly.State:=cbChecked
                                   else FmSetAttr.CBReadOnly.State:=cbUnchecked;
        if (Attr and faArchive)>0 then FmSetAttr.CBArchive.State:=cbChecked
                                  else FmSetAttr.CBArchive.State:=cbUnchecked;
        if (Attr and faHidden)>0 then FmSetAttr.CBHidden.State:=cbChecked
                                 else FmSetAttr.CBHidden.State:=cbUnchecked;
        if (Attr and faSysFile)>0 then FmSetAttr.CBSysFile.State:=cbChecked
                                  else FmSetAttr.CBSysFile.State:=cbUnchecked;
        if Time>0 then
         begin
          DateTime:=FileDateToDateTime(Time);
          FmSetAttr.DateEdit.Text:=DateToStr(DateTime);
          FmSetAttr.TimeEdit.Text:=TimeToStr(DateTime);
         end;
       end;
      if FmSetAttr.ShowModal=mrOk then
       begin
        lAttr:=0;
        if FmSetAttr.CBReadOnly.State=cbChecked then lAttr:=lAttr+faReadOnly;
        if FmSetAttr.CBArchive.State=cbChecked then lAttr:=lAttr+faArchive;
        if FmSetAttr.CBHidden.State=cbChecked then lAttr:=lAttr+faHidden;
        if FmSetAttr.CBSysFile.State=cbChecked then lAttr:=lAttr+faSysFile;
        if FmSetAttr.CheckBox6.Checked then
         try
          DateTime:=StrToTime(FmSetAttr.TimeEdit.Text)+StrToDate(FmSetAttr.DateEdit.Text);
          lFileDate:=DateTimeToFileDate(DateTime);
         except
          lFileDate:=0;
         end
        else
         lFileDate:=0;
        with Panel[ActivePanel] do
         FileSetAttrDate(Drive+':'+Path+FileRec.GetName,lAttr,lFileDate);
        PanelRefresh(ActivePanel);
        i:=0;
        with Panel[ActivePanel] do
         begin
          while (ListBox.Items.Objects[i] as TFileRec).GetName<>FileRec.GetName do
           inc(i);
          ListBox.ItemIndex:=i;
         end;
       end;
     end;
  2: begin
      if FmSetAttr.ShowModal=mrOk then
       begin
        lAttrSet:=0;
        lAttrClear:=faArchive+faReadOnly+faSysFile+faHidden;

        if FmSetAttr.CBReadOnly.State=cbChecked then lAttrSet:=lAttrSet+faReadOnly;
        if FmSetAttr.CBArchive.State=cbChecked then lAttrSet:=lAttrSet+faArchive;
        if FmSetAttr.CBHidden.State=cbChecked then lAttrSet:=lAttrSet+faHidden;
        if FmSetAttr.CBSysFile.State=cbChecked then lAttrSet:=lAttrSet+faSysFile;

        if FmSetAttr.CBReadOnly.State=cbUnchecked then lAttrClear:=lAttrClear-faReadOnly;
        if FmSetAttr.CBArchive.State=cbUnchecked then lAttrClear:=lAttrClear-faArchive;
        if FmSetAttr.CBHidden.State=cbUnchecked then lAttrClear:=lAttrClear-faHidden;
        if FmSetAttr.CBSysFile.State=cbUnchecked then lAttrClear:=lAttrClear-faSysFile;

        lRecurse:=FmSetAttr.CheckBox1.Checked;
        if FmSetAttr.CheckBox6.Checked then
         try
          DateTime:=StrToTime(FmSetAttr.TimeEdit.Text)+StrToDate(FmSetAttr.DateEdit.Text);
          lFileDate:=DateTimeToFileDate(DateTime);
         except
          lFileDate:=0;
         end
        else
         lFileDate:=0;
        DoBatchAction(acSetAttr, lRecurse, lAttrSet, lAttrClear, lFileDate);
       end;
     end;
 end;

 FmSetAttr.Free;
end;

procedure TForm1.ListBox1Enter(Sender: TObject);
begin
 LastClicked:=-1;
 ActivePanel:=ptLeftPanel;
 PanelActivate(ActivePanel,true);
end;

procedure TForm1.ListBox1Exit(Sender: TObject);
begin
 PanelActivate(ptLeftPanel,false);
end;

procedure TForm1.Label2Click(Sender: TObject);
begin
 ListBox1.SetFocus;
end;

procedure TForm1.Label6Click(Sender: TObject);
begin
 ListBox2.SetFocus;
end;

procedure TForm1.ComboBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var dropstate:longint;
begin
 dropstate:=SendMessage(ComboBox1.Handle,CB_GETDROPPEDSTATE,0,0);
 if key=vk_return then
  listbox1.setfocus;
 if key=vk_escape then
  begin
   combobox1.itemindex:=cb1oldvalue;
   listbox1.setfocus;
  end;
 if (key=vk_up) or (key=vk_down) or (key=vk_home) or (key=vk_end)
 or (key=vk_prior) or (key=vk_next)
 then
 if dropstate=0 then
  SendMessage(ComboBox1.Handle,CB_SHOWDROPDOWN,1,0);
end;

procedure TForm1.ComboBox3KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var dropstate:longint;
begin
 dropstate:=SendMessage(ComboBox3.Handle,CB_GETDROPPEDSTATE,0,0);
 if key=vk_return then
  listbox2.setfocus;
 if key=vk_escape then
  begin
   combobox3.itemindex:=cb2oldvalue;
   listbox2.setfocus;
  end;
 if (key=vk_up) or (key=vk_down) or (key=vk_home) or (key=vk_end)
 or (key=vk_prior) or (key=vk_next)
 then
 if dropstate=0 then
  SendMessage(ComboBox3.Handle,CB_SHOWDROPDOWN,1,0);
end;

procedure TForm1.ComboBox3Change(Sender: TObject);
var dropstate:longint;
begin
 dropstate:=SendMessage(ComboBox3.Handle,CB_GETDROPPEDSTATE,0,0);
 if dropstate=0 then
  listbox2.setfocus;
end;

procedure TForm1.ComboBox3Exit(Sender: TObject);
begin
 if cb2oldvalue<>combobox3.itemindex then
  with Panel[ActivePanel] do
   begin
    Drive:=DriveComboBox.Items.Strings[DriveComboBox.ItemIndex][1];
    Path:='\';
    PostMessage(Handle, WM_PANELREFRESH, 0,0);
    ListBox2.SetFocus;
   end
  else
   listbox2exit(sender);
end;

procedure TForm1.ComboBox1Enter(Sender: TObject);
begin
 ListBox1Enter(Sender);
 cb1oldvalue:=combobox1.itemindex;
end;

procedure TForm1.ComboBox3Enter(Sender: TObject);
begin
 ListBox2Enter(Sender);
 cb2oldvalue:=combobox3.itemindex;
end;

procedure TForm1.ListBox2Enter(Sender: TObject);
begin
 LastClicked:=-1;
 ActivePanel:=ptRightPanel;
 PanelActivate(ActivePanel,true);
end;

procedure TForm1.ListBox2Exit(Sender: TObject);
begin
 PanelActivate(ptRightPanel,false);
end;

procedure TForm1.ProgramsItemClick(Sender: TObject);
begin
 with Panel[ActivePanel] do
  begin
   Mask:='*.exe;*.com;*.bat';
   UpdateMaskMenu(Mask,false);
  end;
 PanelRefresh(ActivePanel);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  Value: Integer;
  APoint: TPoint;
begin
 Timer1.Enabled:=False;
 GetCursorPos(APoint);
 with Panel[ActivePanel].ListBox do
  begin
    APoint:=ScreenToClient(APoint);
    Value :=ItemAtPos(APoint, True);
    if LastClicked=Value then
     begin
      InPlaceEdit.Parent:=Panel[ActivePanel].ListBox;
      InPlaceEdit.Top :=  (ItemIndex - TopIndex)*ItemHeight-2;
      InPlaceEdit.Left := 2;
      InPlaceEdit.Width := ClientWidth * 2 div 3;
      InPlaceEdit.Text := (Items.Objects[Value] as TFileRec).GetName;
      if InPlaceEdit.Text<>'..' then
       begin
        InPlaceEdit.Visible := True;
        InPlaceEdit.SetFocus;
       end;
     end;
  end;
end;

procedure TForm1.AppMessage(var Msg: TMsg; var Handled: Boolean);
begin
 if Msg.Message=WM_PANELREFRESH then
  begin
   PanelRefresh(ActivePanel);
   Handled:=true;
  end;
end;

procedure TForm1.Brief1Click(Sender: TObject);
begin
 with Panel[ActivePanel] do
  begin
   ListBox.Columns:=3;
   Style:=psBrief;
   ListBox.Refresh;
  end;
 Brief1.Checked:=true;
 Full1.Checked:=false;
end;

procedure TForm1.Full1Click(Sender: TObject);
begin
 with Panel[ActivePanel] do
  begin
   ListBox.Columns:=0;
   Style:=psFull;
   ListBox.Refresh;
  end;
 Brief1.Checked:=false;
 Full1.Checked:=true;
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
 PanelRefresh(ActivePanel);
end;

procedure TForm1.Portfolioasociations1Click(Sender: TObject);
begin
 FmPfAssoc:=TFmPfAssoc.Create(Form1);
 FmPfAssoc.ShowModal;
 FmPfAssoc.Free;
end;

procedure TForm1.Opto1Click(Sender: TObject);
begin
 FormOption:=TFormOption.Create(Form1);
 if FormOption.ShowModal=mrOK then
  begin
   ReadOptions;
   PanelRefresh(ptLeftPanel);
   PanelRefresh(ptRightPanel);
  end;
 FormOption.Free;
end;

procedure TForm1.ReadOptions;
var PomInt: integer;
begin
  with FTIniFile do
   begin
    PomInt:=ReadInteger('OPTIONS', 'Interface', 1);
    if PomInt=1 then PFForm.PFInterface:=ifParalell
                else PFForm.PFInterface:=ifSerial;
    PFForm.PFComPort:='COM'+IntToStr(ReadInteger('OPTIONS','Com',0)+1);
    PFForm.PFLptPort:=ReadInteger('OPTIONS','Lpt',$0378);
   end;
 end;

procedure TForm1.About1Click(Sender: TObject);
begin
 AboutBox:=TAboutBox.Create(Form1);
 AboutBox.ShowModal;
 AboutBox.Free;
end;

end.
